#!/bin/sh

#
# volia cable pinger script
# created by gaaronk (2:463/419) 
#

wan1_host1=`nvram get wan1_testip_1`
wan1_host2=`nvram get wan1_testip_2`
wan2_host1=`nvram get wan2_testip_1`
wan2_host2=`nvram get wan2_testip_2`

wan1_flip_trsh=3    
wan1_dead_trsh=3       
wan1_live_trsh=8

wan2_flip_trsh=3
wan2_dead_trsh=3
wan2_live_trsh=10

logf=/tmp/pinger.log

wan1flag=/tmp/wan1.online
wan2flag=/tmp/wan2.online

echo `date '+%d/%m/%y %H:%M:%S'` >> $logf
echo `date '+%d/%m/%y %H:%M:%S'` pinger script start >> $logf

if [ -f $wan1flag ]; then echo `date '+%d/%m/%y %H:%M:%S'` wan1 is online now >> $logf
                     else echo `date '+%d/%m/%y %H:%M:%S'` wan1 is offline now >> $logf
fi		     

if [ -f $wan2flag ]; then echo `date '+%d/%m/%y %H:%M:%S'` wan2 is online now >> $logf
                     else echo `date '+%d/%m/%y %H:%M:%S'` wan2 is offline now >> $logf
fi

wan1_live_c=0
wan1_dead_c=0
wan2_live_c=0
wan2_dead_c=0

 
while true; do 

    if ping -c 1 $wan1_host1 > /dev/null 2>&1 || ping -c 1 $wan1_host2 > /dev/null 2>&1 ; then
	wan1_live_c=`expr $wan1_live_c + 1`
        if [ $wan1_live_c -ge $wan1_flip_trsh ]; then wan1_dead_c=0; fi
    else
        wan1_dead_c=`expr $wan1_dead_c + 1`
        wan1_live_c=0
    fi
    
    if ping -c 1 $wan2_host1 > /dev/null 2>&1 || ping -c 1 $wan2_host2 > /dev/null 2>&1 ; then
    	wan2_live_c=`expr $wan2_live_c + 1`
    	if [ $wan2_live_c -ge $wan2_flip_trsh ]; then wan2_dead_c=0; fi
    else
    	wan2_dead_c=`expr $wan2_dead_c + 1`
    	wan2_live_c=0
    fi
    

    if [ ! -f $wan1flag ] && [ $wan1_live_c -ge $wan1_live_trsh ]; then 
        touch $wan1flag
        echo `date '+%d/%m/%y %H:%M:%S'` "### WAN1 is ALIVE! ### count: $wan1_live_c ###" >> $logf
        /usr/local/sbin/swroute.sh
    fi

    if [ ! -f $wan2flag ] && [ $wan2_live_c -ge $wan2_live_trsh ]; then
    	touch $wan2flag
    	rm $dhcpflag
    	echo `date '+%d/%m/%y %H:%M:%S'` "### WAN2 is ALIVE! ### count: $wan2_live_c ###" >> $logf
    	/usr/local/sbin/swroute.sh
    fi 
 
    if [ -f $wan1flag ] && [ $wan1_dead_c -ge $wan1_dead_trsh ]; then
        rm $wan1flag
        echo `date '+%d/%m/%y %H:%M:%S'`  "### WAN1 is DEAD! ### count: $wan1_dead_c ###" >> $logf
        /usr/local/sbin/swroute.sh
    fi
    
    if [ -f $wan2flag ] && [ $wan2_dead_c -ge $wan2_dead_trsh ]; then
    	rm $wan2flag
    	touch $dhcpflag
    	echo `date '+%d/%m/%y %H:%M:%S'`  "### WAN2 is DEAD! ### count: $wan2_dead_c ###" >> $logf
    	/usr/local/sbin/swroute.sh
    fi

    if [ $wan1_live_c -gt 10000 ]; then 
        wan1_live_c=100
        echo `date '+%d/%m/%y %H:%M:%S'`  reduce \"wan1 live\" counter from 10000 to 100 >> $logf
    fi

    if [ $wan2_live_c -gt 10000 ]; then
    	wan2_live_c=100
    	echo `date '+%d/%m/%y %H:%M:%S'`  reduce \"wan2 live\" counter from 10000 to 100 >> $logf
    fi

    sleep 10

done

exit 0
